/*
 * Created on 2019-08-18 ( Time 17:15:05 )
 * Generated by Telosys Tools Generator ( version 3.0.0 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.diaspora.star.motors.sarl.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;

import javax.persistence.*;

/**
 * Persistent class for entity stored in table "bon_decaissement"
 *
 * @author Telosys Tools Generator
 *
 */

@Entity
@Table(name="bon_decaissement" )
public class BonDecaissement implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_chef_atelier")
    private Boolean    isValidedByChefAtelier ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_responsable_technique")
    private Boolean    isValidedByResponsableTechnique ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_responsable_decaissement")
    private Boolean    isValidedByResponsableDecaissement ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_responsable_achat")
    private Boolean    isValidedByResponsableAchat ;

	// "devisId" (column "devis_id") is not defined by itself because used as FK in a link 
	// "etatId" (column "etat_id") is not defined by itself because used as FK in a link 
	// "userChefAtelierId" (column "user_chef_atelier_id") is not defined by itself because used as FK in a link 
	// "userResponsableTechniqueId" (column "user_responsable_technique_id") is not defined by itself because used as FK in a link 
	// "userResponsableDecaissementId" (column "user_responsable_decaissement_id") is not defined by itself because used as FK in a link 
	// "userResponsableAchatId" (column "user_responsable_achat_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="user_responsable_technique_id", referencedColumnName="id")
    private User userResponsableTechnique       ;
    @ManyToOne
    @JoinColumn(name="user_chef_atelier_id", referencedColumnName="id")
    private User userChefAtelier        ;
    @ManyToOne
    @JoinColumn(name="user_responsable_decaissement_id", referencedColumnName="id")
    private User userResponsableDecaissement       ;
    @ManyToOne
    @JoinColumn(name="devis_id", referencedColumnName="id")
    private Devis devis       ;
    @ManyToOne
    @JoinColumn(name="etat_id", referencedColumnName="id")
    private Etat etat        ;
    @ManyToOne
    @JoinColumn(name="user_responsable_achat_id", referencedColumnName="id")
    //private User user2       ;
    private User userResponsableAchat       ;

    //----------------------------------------------------------------------
    // CONSTRUCTOR(S)
    //----------------------------------------------------------------------
    public BonDecaissement() {
		super();
    }
    
    //----------------------------------------------------------------------
    // GETTER & SETTER FOR THE KEY FIELD
    //----------------------------------------------------------------------
    public void setId( Integer id ) {
        this.id = id ;
    }
    public Integer getId() {
        return this.id;
    }

    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR FIELDS
    //----------------------------------------------------------------------
    //--- DATABASE MAPPING : is_deleted ( BIT ) 
    public void setIsDeleted( Boolean isDeleted ) {
        this.isDeleted = isDeleted;
    }
    public Boolean getIsDeleted() {
        return this.isDeleted;
    }

    //--- DATABASE MAPPING : created_at ( DATETIME ) 
    public void setCreatedAt( Date createdAt ) {
        this.createdAt = createdAt;
    }
    public Date getCreatedAt() {
        return this.createdAt;
    }

    //--- DATABASE MAPPING : updated_at ( DATETIME ) 
    public void setUpdatedAt( Date updatedAt ) {
        this.updatedAt = updatedAt;
    }
    public Date getUpdatedAt() {
        return this.updatedAt;
    }

    //--- DATABASE MAPPING : deleted_at ( DATETIME ) 
    public void setDeletedAt( Date deletedAt ) {
        this.deletedAt = deletedAt;
    }
    public Date getDeletedAt() {
        return this.deletedAt;
    }

    //--- DATABASE MAPPING : created_by ( INT ) 
    public void setCreatedBy( Integer createdBy ) {
        this.createdBy = createdBy;
    }
    public Integer getCreatedBy() {
        return this.createdBy;
    }

    //--- DATABASE MAPPING : updated_by ( INT ) 
    public void setUpdatedBy( Integer updatedBy ) {
        this.updatedBy = updatedBy;
    }
    public Integer getUpdatedBy() {
        return this.updatedBy;
    }

    //--- DATABASE MAPPING : deleted_by ( INT ) 
    public void setDeletedBy( Integer deletedBy ) {
        this.deletedBy = deletedBy;
    }
    public Integer getDeletedBy() {
        return this.deletedBy;
    }

    //--- DATABASE MAPPING : is_valided_by_chef_atelier ( BIT ) 
    public void setIsValidedByChefAtelier( Boolean isValidedByChefAtelier ) {
        this.isValidedByChefAtelier = isValidedByChefAtelier;
    }
    public Boolean getIsValidedByChefAtelier() {
        return this.isValidedByChefAtelier;
    }

    //--- DATABASE MAPPING : is_valided_by_responsable_technique ( BIT ) 
    public void setIsValidedByResponsableTechnique( Boolean isValidedByResponsableTechnique ) {
        this.isValidedByResponsableTechnique = isValidedByResponsableTechnique;
    }
    public Boolean getIsValidedByResponsableTechnique() {
        return this.isValidedByResponsableTechnique;
    }

    //--- DATABASE MAPPING : is_valided_by_responsable_decaissement ( BIT ) 
    public void setIsValidedByResponsableDecaissement( Boolean isValidedByResponsableDecaissement ) {
        this.isValidedByResponsableDecaissement = isValidedByResponsableDecaissement;
    }
    public Boolean getIsValidedByResponsableDecaissement() {
        return this.isValidedByResponsableDecaissement;
    }

    //--- DATABASE MAPPING : is_valided_by_responsable_achat ( BIT ) 
    public void setIsValidedByResponsableAchat( Boolean isValidedByResponsableAchat ) {
        this.isValidedByResponsableAchat = isValidedByResponsableAchat;
    }
    public Boolean getIsValidedByResponsableAchat() {
        return this.isValidedByResponsableAchat;
    }


    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR LINKS
    //----------------------------------------------------------------------

    public void setUserResponsableTechnique( User userResponsableTechnique ) {
        this.userResponsableTechnique = userResponsableTechnique;
    }
    public User getUserResponsableTechnique() {
        return this.userResponsableTechnique;
    }


    public void setUser( User userChefAtelier ) {
        this.userChefAtelier = userChefAtelier;
    }
    public User getUserChefAtelier() {
        return this.userChefAtelier;
    }


    public void setUserResponsableDecaissement( User userResponsableDecaissement ) {
        this.userResponsableDecaissement = userResponsableDecaissement;
    }
    public User getUserResponsableDecaissement() {
        return this.userResponsableDecaissement;
    }


    public void setDevis( Devis devis ) {
        this.devis = devis;
    }
    public Devis getDevis() {
        return this.devis;
    }


    public void setEtat( Etat etat ) {
        this.etat = etat;
    }
    public Etat getEtat() {
        return this.etat;
    }


    public void setUserResponsableAchat( User userResponsableAchat ) {
        this.userResponsableAchat = userResponsableAchat;
    }
    public User getUserResponsableAchat() {
        return this.userResponsableAchat;
    }


    public void setUserChefAtelier(User userChefAtelier) {
		this.userChefAtelier = userChefAtelier;
	}

	//----------------------------------------------------------------------
    // toString METHOD
    //----------------------------------------------------------------------
    public String toString() { 
        StringBuffer sb = new StringBuffer(); 
        sb.append("["); 
        sb.append(id);
        sb.append("]:"); 
        sb.append(isDeleted);
        sb.append("|");
        sb.append(createdAt);
        sb.append("|");
        sb.append(updatedAt);
        sb.append("|");
        sb.append(deletedAt);
        sb.append("|");
        sb.append(createdBy);
        sb.append("|");
        sb.append(updatedBy);
        sb.append("|");
        sb.append(deletedBy);
        sb.append("|");
        sb.append(isValidedByChefAtelier);
        sb.append("|");
        sb.append(isValidedByResponsableTechnique);
        sb.append("|");
        sb.append(isValidedByResponsableDecaissement);
        sb.append("|");
        sb.append(isValidedByResponsableAchat);
        return sb.toString(); 
    } 

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
